<template lang="pug">
  apollo-query(
    ref="index"
    :query="$options.listNotificationsForUserGql"
    :pollInterval="60*1000"
    @loading="(loading) => loading ? $nuxt.$loading.start() : $nuxt.$loading.finish()"
    #default="{ result: { loading, error, data }, isLoading, query }"
  )
    apollo-subscribe-to-more(
      :document="$options.onNewNotificationForUserGql"
      :updateQuery="(previousResult, { subscriptionData }) => updateQuery(previousResult, subscriptionData)"
    )
    z-button.btn-action(
      v-if="data && data.notificationsForUser && data.notificationsForUser.totalUnreadCount"
      circle
      :badge="`${data.notificationsForUser.totalUnreadCount}`"
      @click="toggleDrawer"
      v-shortkey.once="{ long: ['ctrl', 'a'], short: ['a'] }"
      @shortkey.native="toggleDrawer"
    )
      z-icon(name="notifications")
    z-button.btn-action(
      v-else
      circle
      @click="toggleDrawer"
      v-shortkey.once="{ long: ['ctrl', 'a'], short: ['a'] }"
      @shortkey.native="toggleDrawer"
    )
      z-icon(name="notifications")
</template>

<script>
import listNotificationsForUserGql from '~/apollo/queries/listNotificationsForUser'
import onNewNotificationForUserGql from '~/apollo/subscriptions/onNewNotificationForUser'

export default {
  listNotificationsForUserGql,
  onNewNotificationForUserGql,

  methods: {
    updateQuery(previousResult, subscriptionData) {
      const newResult = { ...previousResult }
      newResult.notificationsForUser.totalCount += 1
      return newResult
    },
    toggleDrawer() {
      this.$store.dispatch('user/DRAWER_TOGGLE')
    }
  }
}
</script>
